<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Mail\Mailables\Content;
use Illuminate\Mail\Mailables\Envelope;
use Illuminate\Queue\SerializesModels;
use DateTime;

class Calibration extends Mailable
{
    use Queueable, SerializesModels;
    public $tableData;
    public $scheduleType;

    /**
     * Create a new message instance.
    */
    public function __construct($scheduleType,$tableData = [])
    {
         $this->scheduleType = $scheduleType;
         $this->tableData = $tableData ?? [];
    }


    /**
     * Get the message envelope.
     */
    public function envelope(): Envelope
    {
        return new Envelope(
            subject: 'Calibration Mail',
        );
    }

    public function content(): Content
    {
        $greeting = "Dear Sir/Madam,<br><br>Kindly find the attached calibration report status details for the 'calibrated on' and 'calibrated next date'";

        if ($this->scheduleType == 'Daily') {
            $fromDate = (new DateTime('yesterday 08:00'))->format('d/m/Y H:i') . ':000';
            $toDate = (new DateTime('today 07:59'))->format('d/m/Y H:i') . ':999';
            $reportPeriod = "The following report presents results from: $fromDate to $toDate.";
            $greeting .= $reportPeriod;
        }

        if ($this->scheduleType == 'Hourly') {
            $now = now();
            $fromHour = $now->copy()->subHour()->format('H:i:s');
            $toHour = $now->format('H:i:s');
            $reportDate = $now->format('d/m/Y');
            $greeting .= "The following report presents results from: $reportDate, $fromHour to $toHour.";
        }

        if ($this->scheduleType == 'Live') {
            $now = now();
            $fromMinute = $now->copy()->subMinute()->format('d/m/Y H:i:s');
            $toMinute   = $now->format('d/m/Y H:i:s');
            $greeting .= "The following report presents results from: $fromMinute to $toMinute.";
        }

        return new Content(
            view: 'mail.calibration_report',
            with: [
                'company' => "CRI Digital Manufacturing Solutions",
                'greeting' => $greeting,
                'tableData' => $this->tableData,
                'wishes' => "Thanks & Regards,<br>CRI Digital Manufacturing Solutions"
            ],
        );
    }

    /**
     * Get the attachments for the message.
     *
     * @return array<int, \Illuminate\Mail\Mailables\Attachment>
     */
    public function attachments(): array
    {
        return [];
    }
}
